### setup.py ###
from distutils.core import setup
from optparse import OptionParser
import os
import sys

def get_data_files():
    data_files = []
    for data_dir in ['../specs', '../doc', '../output']:
        for root, dirs, files in os.walk(data_dir):
            for name in files:
                root1 = root[3:]
                data_files.append(('share/stacklet/' + root1, [os.path.join(root,name)]))

    return data_files

pkglist = ["stacklet"
         , "stacklet.util"
         , "stacklet.task"
         , "stacklet.task.distro"
         , "stacklet.task.image"
         , "stacklet.task.user"
         , "stacklet.factory"]

setup (name = 'Stacklet',
      version = '1.00',
      description = 'Generate Virtual Images On The Fly',
      author_email = 'dfn@stacklet.com',
      url = 'http://stacklet.com',
      license = 'GPL',
      scripts = ["bin/stackfactory"],
      packages = pkglist,
      package_data={'stacklet.factory': ['logger.conf']},
      data_files = get_data_files())

try:
    os.mkdir('/var/stacklet')
    os.mkdir('/mnt/loop')
except:
    pass	