"""Tasks for executing commands.

Please see docstring of each class for usage.

"""
from gnosis.xml.objectify import _XO_
from gnosis.xml.objectify import *

from stacklet.task.stacktask import *
from stacklet.task.stackerror import *

class _XO_command(_XO_, StackTask):
    """Execute a command in the image under construction (chrooted)

    Task Arguments:
    the command

    """
    _TASK_NAME = 'command'

    def __init__(self):
        pass

    def process(self, buildContext):
        try:
            try:
                self._buildContext = buildContext
                self.log_info(buildContext, 'entering')
                self.precheck(buildContext)
                cmds = list()
                cmds.append(self._cmd)
                self.exec_command_chroot(buildContext, cmds)
            except TaskError, taskErr:
                if taskErr.criticality == TaskError.ABORT_BUILD:
                    raise
                self.log_error(buildContext, taskErr)
        finally:
            self.log_info(buildContext, 'leaving')

    def precheck(self, buildContext):
        self.is_valid_build_context(buildContext)
        self._cmd = self.get_value(None)

        if self.is_empty(self._cmd):
            raise FieldError(self._TASK_NAME, TaskError.ABORT_TASK, 'command is required')


gnosis.xml.objectify._XO_command = _XO_command
gnosis.xml.objectify._XO_stk_command = _XO_command
