"""Task for creating directories.

Please see docstring of each class for usage.

"""
import os

from gnosis.xml.objectify import _XO_
from gnosis.xml.objectify import *

from stacklet.task.stacktask import *
from stacklet.task.stackerror import *

class _XO_directory(_XO_, StackTask):
    """Create a directory in the image under construction.

    Task Arguments:
    loc -- the complete path of the directory, intermediate directories will be created if necessary
    """
    _TASK_NAME = 'directory'

    def __init__(self):
        pass

    def process(self, buildContext):

        try:
            try:
                self._buildContext = buildContext
                self.log_info(buildContext, 'entering')
                self.precheck(buildContext)
                dirPath = buildContext.mountPoint + self._loc
                cmd='mkdir -p ' + dirPath
                self.exec_command(buildContext, cmd)
            except TaskError, taskErr:
                if taskErr.criticality == TaskError.ABORT_BUILD:
                    raise
                self.log_error(buildContext, taskErr)
        finally:
            self.log_info(buildContext, 'leaving')

    def precheck(self, buildContext):
        self.is_valid_build_context(buildContext)

        self._loc = self.get_value('loc')

        if self.is_empty(self._loc):
            raise FieldError(self._TASK_NAME, TaskError.ABORT_TASK, 'loc is required')
        elif not self._loc.startswith(os.sep):
            raise FieldError(self._TASK_NAME, TaskError.ABORT_TASK, 'loc must start with ' + os.sep)

gnosis.xml.objectify._XO_directory = _XO_directory
gnosis.xml.objectify._XO_stk_directory = _XO_directory

