"""Tasks for manipulating user accounts.

Please see docstring of each class for usage.

"""
from gnosis.xml.objectify import _XO_
from gnosis.xml.objectify import *

from stacklet.task.stacktask import *
from stacklet.task.stackerror import *

class _XO_password(_XO_, StackTask):
    """Set the password for a user inside of the image under construction.

    Task Arguments:
    user -- the user whose password is being set (must already exist)
    password -- the unencrypted password

    """
    _TASK_NAME = 'password'

    def __init__(self):
        pass

    def process(self, buildContext):
        try:
            try:
                self._buildContext = buildContext
                self.log_info(buildContext, 'entering')
                self.precheck(buildContext)
                cmds = list()
                cmds.append('echo ' +  self._user + ':' + self._password + ' | /usr/sbin/chpasswd')
                self.exec_command_chroot(buildContext, cmds)
            except TaskError, taskErr:
                if taskErr.criticality == TaskError.ABORT_BUILD:
                    raise
                self.log_error(buildContext, taskErr)
        finally:
            self.log_info(buildContext, 'leaving')

    def precheck(self, buildContext):
        self.is_valid_build_context(buildContext)

        self._user = self.get_value('user')
        self._password = self.get_value('password')
        print type(self._user)
        if self.is_empty(self._user):
            raise FieldError(self._TASK_NAME, TaskError.ABORT_TASK, 'user is required')

        if self.is_empty(self._password):
            raise FieldError(self._TASK_NAME, TaskError.ABORT_TASK, 'password is required')

gnosis.xml.objectify._XO_password = _XO_password
gnosis.xml.objectify._XO_stk_password = _XO_password

