"""String utilities.
"""
import re
from re import findall,sub

def substitute_vars(dict, text):
    """ Replace in text all occurences of any key in the given
        dictionary by its corresponding value.  Returns the new string."""

    try:
        # Create a regular expression  from the dictionary keys
        regex = re.compile("(%s)" % "|".join(map(re.escape, dict.keys())))

        # For each match, look-up corresponding value in dictionary
        return regex.sub(lambda mo: dict[mo.string[mo.start():mo.end()]], text)
    except:
        return text

def flush_left(text):
    """Remove leading spaces from all lines in a string while keeping relative indentation. """
    try:
        indent = lambda s: reduce(min,map(len,findall('(?m)^ *(?=\S)',s)))
        flush = lambda s: sub('(?m)^ {%d}' % indent(s),'',s)
        return flush(text)
    except:
        return text

